Bug 5889 - порча fstab
: порча fstab
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/hotplug)
: unstable
: all Linux
: P2 blocker
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2005-01-17 18:48 by
Modified: 2007-01-27 13:49 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-01-17 18:48:14
в общем, при первой же загрузке с вставленной флэшкой, fstab был уничтожен
как и fstab.backup, создаваемый block.agent'ом ;)
все ручные записи исчезли, зато добавилось несколько хотплаговых
с md-x и sdax
откуда берется md-x я не смотрел, но с некоторых пор мне при загрузке упорно
сообщается, что он не найден. но это, видимо, не имеет отношения к делу, кроме
того, что было несколько запусков block.agent'а
я, конечно, додумался fstab сохранить, но зачем такой хотплаг, за которым все
равно руками исправлять
я подумал и поправил block.agent так:

--- block.agent 2004-12-28 16:36:37 +0200
+++ block.agent.new     2005-01-15 15:41:03 +0200
@@ -56,12 +56,12 @@
     OPT=`echo $OPT|sed -e
"s/iocharset=/iocharset=$CHARSET/;s/codepage=/codepage=$CODEPAGE/"`
     stnum="_$DEVNAME"
     mkdir -p $STMNT$stnum
-    cp -a /etc/fstab /etc/fstab.new
-    cp -af /etc/fstab /etc/fstab.backup
+    cp -a /etc/fstab /etc/fstab.new.$$
+    cp -af /etc/fstab.new.$$ /etc/fstab.backup
     sync
-    echo "$DEV $STMNT$stnum    $FS     $OPT    0       0 #hotplug"
>>/etc/fstab.new
+    echo "$DEV $STMNT$stnum    $FS     $OPT    0       0 #hotplug"
>>/etc/fstab.new.$$
     sync
-    mv -f /etc/fstab.new /etc/fstab
+    mv -f /etc/fstab.new.$$ /etc/fstab
     sync
     ;;

@@ -82,9 +82,9 @@
     fi
     umount -f -l "$stdir" >/dev/null 2>&1 ||:
     cp -af /etc/fstab /etc/fstab.backup
-    grep -v --regexp="^$DEV[[:blank:]].*$" /etc/fstab >/etc/fstab.tmp
+    grep -v --regexp="^$DEV[[:blank:]].*$" /etc/fstab >/etc/fstab.tmp.$$
     sync
-    mv -f /etc/fstab.tmp /etc/fstab
+    mv -f /etc/fstab.tmp.$$ /etc/fstab
     sync
     rmdir "$stdir"
     ;;


вроде, помогло...
------- Comment #1 From 2005-01-25 02:46:07 -------
После установки на машину serial-ATA диска (он определился 
как /dev/sda) и создания разделов с помощью fdisk, 
далее 
Command (m for help): w 
The partition table has been altered! 
Calling ioctl() to re-read partition table. 
обнаруживаю, что fstab пустой абсолютно. 
Надеюсь, писатель hotplug не решил, что sda это флэшка forever? 
------- Comment #2 From 2005-01-25 03:23:54 -------
Это действительно происходит при добавлении новых разделов 
на /dev/sda и перечитывании таблицы на них из fdisk например. 
При этом в fstab появляются строки типа 
/dev/sda6   /media/storage_sda6 auto    user,noexec,nosuid,nodev,sync   0   0 
#hotplug 

У меня есть серьёзное предложение прекратить развлекаться как маленькие дети 
копированием скриптом на bash важнейшего в файла в система fstab, 
не танцевать перед флешками, а добавить возможность читать содержимое 
каталога /etc/fstab.d и патчить те программы, которые этого не поймут. 

Не то чтобы Сизиф на сервере стоит, но место разработчика - на Сизифе, и 
разработка ALT начинает дорого стоить. 
------- Comment #3 From 2005-01-25 04:54:20 -------
ну, а патчик мой помогает при этом ?
------- Comment #4 From 2005-01-25 11:44:52 -------
Виталий, все будут только благодарны, если вы это сделаете (fstab.d).
------- Comment #5 From 2005-01-25 11:45:26 -------
Виталий, попробуйте патч.
------- Comment #6 From 2005-01-25 15:49:27 -------
fixed (hotplug-2004_09_23-alt6)
------- Comment #7 From 2005-07-14 19:38:01 -------
(In reply to comment #4) 
> Виталий, все будут только благодарны, если вы это сделаете (fstab.d). 
>  
сделали (см. #7366)